/* 
 *   Creation Date: <2002/10/22 23:11:18 samuel>
 *   Time-stamp: <2002/10/22 23:46:37 samuel>
 *   
 *	<unicode.c>
 *	
 *	Unicode support
 *   
 *   Copyright (C) 2002 Samuel Rydh (samuel@ibrium.se)
 *
 *   Based upon code written by
 *
 *   Copyright (C) 1999-2000  Brad Boyer (flar@pants.nu)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#include "mol_config.h"
#include <endian.h>
#include <byteswap.h>
#include <linux/string.h>
#ifndef __USE_GNU
#define __USE_GNU
#endif
#include <wchar.h>

int
asc2uni( ushort *ustr, const char *astr, int maxlen )
{
	mbstate_t mbstate = { 0, {0} };    /* Multibyte state */
	int len, total = 0;
	wchar_t wc;

	while( *astr && total < maxlen ) {
		len = mbrtowc(&wc, astr, MB_CUR_MAX, &mbstate);
		if( !len )	// eof
			break;
		if( len < 0 )	// error
			continue;
		astr += len;
		total += len;
		*ustr++ = wc;
	}
	return total;
}

int
uni2asc( char *astr, ushort *ustr, int ustrlen, int maxlen )
{
	int len, total;
	mbstate_t mbstate = { 0, {0} };    /* Multibyte state */
	
	maxlen -= (MB_CUR_MAX + 1);	// leave space for a '\0' and overflow
	total = 0;
	
	while( (ustrlen > 0) && (maxlen > 0) ) {
		wchar_t wc = *ustr++;
		len = wcrtomb(astr, wc, &mbstate);  
		ustrlen--;
		if( len < 0 )		// ignore error ...
			continue;
		maxlen -= len;
		astr += len;
		total += len;
	}
	wcrtomb(astr, 0, &mbstate);	// care about rest of state
	*astr ='\0';
    
	return total;
}
